SoTexture3 Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoTexture3 Class Reference
Node Classes

The SoTexture3 class is used to map a 3D texture onto geometry.Shape nodes within the scope of SoTexture3 nodes in the scenegraph (ie below the same SoSeparator and to the righthand side of the SoTexture3) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc etc) for information about the specifics of how the textures will be applied. An SoTexture3 node will override any previous encountered SoTexture2 nodes and vice versa. Mixing of SoTexture3 and SoTextureCoordinate2 (or the other way around) is legal, but the third texture coordinate component will be ignored (set to 0.0). More...

`#include <Inventor/nodes/SoTexture3.h>`

Inherits SoTexture.

## Public Types
enum | Model { MODULATE = SoTextureImageElement::MODULATE, DECAL = SoTextureImageElement::DECAL, BLEND = SoTextureImageElement::BLEND }
enum | Wrap { REPEAT = SoTextureImageElement::REPEAT, CLAMP = SoTextureImageElement::CLAMP }

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoTexture3 (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)

## Public Attributes
SoMFString | filenames
SoSFImage3 | images
SoSFEnum | wrapR
SoSFEnum | wrapS
SoSFEnum | wrapT
SoSFEnum | model
SoSFColor | blendColor
SoSFBool | enableCompressedTexture

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTexture3 ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)
int | getReadStatus (void)
void | setReadStatus (int s)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)

## Detailed Description

The SoTexture3 class is used to map a 3D texture onto geometry.

Shape nodes within the scope of SoTexture3 nodes in the scenegraph (ie below the same SoSeparator and to the righthand side of the SoTexture3) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc etc) for information about the specifics of how the textures will be applied. An SoTexture3 node will override any previous encountered SoTexture2 nodes and vice versa. Mixing of SoTexture3 and SoTextureCoordinate2 (or the other way around) is legal, but the third texture coordinate component will be ignored (set to 0.0).

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

FILE FORMAT/DEFAULTS:

Texture3 {
filenames ""
images 0 0 0 0
wrapR REPEAT
wrapS REPEAT
wrapT REPEAT
model MODULATE
blendColor 0 0 0
enableCompressedTexture FALSE
}

Since
  Coin 2.0
  TGS Inventor 2.6

## Member Enumeration Documentation

enum SoTexture3::Model

Texture mapping model.

Enumerator
MODULATE | Texture image is modulated with polygon.
DECAL | Texture image overwrites polygon color.
BLEND | Blend image using blendColor.

enum SoTexture3::Wrap

Enum used to specify wrapping strategy.

Enumerator
REPEAT | Repeat texture when coordinate is not between 0 and 1.
CLAMP | Clamp coordinate between 0 and 1.

## Constructor & Destructor Documentation

SoTexture3::SoTexture3 | ( | void |  | ) |

Constructor.

SoTexture3::~SoTexture3 | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

SoType SoTexture3::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Implements SoBase.

const SoFieldData * SoTexture3::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

void SoTexture3::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

void SoTexture3::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoNode.

void SoTexture3::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

SbBool SoTexture3::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) |  |
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoTexture3::notify | ( | SoNotList * | l | ) |
| protectedvirtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

int SoTexture3::getReadStatus | ( | void |  | ) |
| protected

Returns read status. 1 for success, 0 for failure.

void SoTexture3::setReadStatus | ( | int | s | ) |
| protected

Sets read status.

See also
  getReadStatus()

## Member Data Documentation

SoMFString SoTexture3::filenames

Texture filename(s). Specify either this or use SoTexture3::images, not both. The depth of the volume is specifies by the number of filenames specified. All images must have the same dimensions and number of components. NB! A field sensor is attached to this field internally and reloads all images when this field changes. You must therefore be careful when setting this field and either use startEditing()/finishEditing() or set all values with one function call; setValues().

SoSFImage3 SoTexture3::images

Inline image data.

SoSFEnum SoTexture3::wrapR

Wrapping strategy for the R coordinate (depth).

SoSFEnum SoTexture3::wrapS

Wrapping strategy for the S coordinate.

SoSFEnum SoTexture3::wrapT

Wrapping strategy for the T coordinate.

SoSFEnum SoTexture3::model

Texture model.

SoSFColor SoTexture3::blendColor

Blend color. Used when SoTexture3::model is SoTexture3::BLEND.

SoSFBool SoTexture3::enableCompressedTexture

Hint to Coin that compressed textures should be used if this is supported by the graphics hardware and OpenGL drivers. Using compressed textures usually reduces texture memory usage for a texture by 4-6 times.

Since
  Coin 2.4.2
  TGS Inventor 4.0

The documentation for this class was generated from the following files:

- SoTexture3.h
- SoTexture3.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.